<?xml version="1.0"?>
<ruleset name="CDR phpmd ruleset"
         xmlns="http://pmd.sf.net/ruleset/1.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://pmd.sf.net/ruleset/1.0.0
                     http://pmd.sf.net/ruleset_xml_schema.xsd"
         xsi:noNamespaceSchemaLocation="http://pmd.sf.net/ruleset_xml_schema.xsd">
  
  <!-- https://github.com/phpmd/phpmd/tree/master/src/main/resources/rulesets -->
  
  <!-- clean code except static access -->
  <rule ref="rulesets/cleancode.xml">
    <exclude name="StaticAccess"/>
  </rule>
  <!-- codesize, with exceptions for cyclomatic complexity and coupling between objects -->
  <rule ref="rulesets/codesize.xml">
    <exclude name="CyclomaticComplexity"/>
    <exclude name="CouplingBetweenObjects"/>
  </rule>
  <rule ref="rulesets/codesize.xml/CyclomaticComplexity">
    <properties>
      <property name="reportLevel" description="The Cyclomatic Complexity reporting threshold"  value="20"/>
    </properties>
  </rule>
  <rule ref="rulesets/design.xml/CouplingBetweenObjects">
    <properties>
      <property name="minimum" value="20" description="Maximum number of acceptable dependencies." />
    </properties>
  </rule>
  <!-- controversial -->
  <rule ref="rulesets/controversial.xml"/>
  <!-- design -->
  <rule ref="rulesets/design.xml"/>
  <!-- naming with exceptions for long and short variables/methods -->
  <rule ref="rulesets/naming.xml">
    <exclude name="LongVariable"/>
    <exclude name="ShortVariable"/>
    <exclude name="ShortMethodName"/>
  </rule>
  <rule ref="rulesets/naming.xml/LongVariable">
    <properties>
      <property name="maximum" value="30"/>
    </properties>
  </rule>
  <rule ref="rulesets/naming.xml/ShortVariable">
    <properties>
      <property name="exceptions" value="id,ip"/>
    </properties>
  </rule>
  <rule ref="rulesets/naming.xml/ShortMethodName">
    <properties>
      <property name="exceptions" value="id"/>
    </properties>
  </rule>
  <!-- unused code -->
  <rule ref="rulesets/unusedcode.xml"/>
</ruleset>
